DPDK patches and discussions
 help / color / mirror / Atom feed
From: Ciara Power <ciara.power@intel.com>
To: thomas@monjalon.net, john.mcnamara@intel.com, marko.kovacevic@intel.com
Cc: ferruh.yigit@intel.com, dev@dpdk.org,
	Ciara Power <ciara.power@intel.com>
Subject: [dpdk-dev] [PATCH v3 2/3] devtools: added stats print
Date: Tue,  2 Jun 2020 14:53:18 +0100	[thread overview]
Message-ID: <20200602135319.21457-3-ciara.power@intel.com> (raw)
In-Reply-To: <20200602135319.21457-1-ciara.power@intel.com>

When all checks are completed on the specified commit logs, the script
indicates if all are valid, or if there were some failures.

Signed-off-by: Ciara Power <ciara.power@intel.com>
Acked-by: Ferruh Yigit <ferruh.yigit@intel.com>

---
v2: Added appropriate exit codes based on failure status.
---
 devtools/check-git-log.sh | 45 +++++++++++++++++++++++++--------------
 1 file changed, 29 insertions(+), 16 deletions(-)

diff --git a/devtools/check-git-log.sh b/devtools/check-git-log.sh
index 5220765b9..eca8506d9 100755
--- a/devtools/check-git-log.sh
+++ b/devtools/check-git-log.sh
@@ -70,7 +70,7 @@ bad=$(echo "$headlines" | grep --color=always \
 	-e ':[^ ]' \
 	-e ' :' \
 	| sed 's,^,\t,')
-[ -z "$bad" ] || printf "Wrong headline format:\n$bad\n"
+[ -z "$bad" ] || { printf "Wrong headline format:\n$bad\n" && failure=true;}
 
 # check headline prefix when touching only drivers, e.g. net/<driver name>
 bad=$(for commit in $commits ; do
@@ -88,7 +88,7 @@ bad=$(for commit in $commits ; do
 		echo "$headline" | grep -v "^$drv"
 	fi
 done | sed 's,^,\t,')
-[ -z "$bad" ] || printf "Wrong headline prefix:\n$bad\n"
+[ -z "$bad" ] || { printf "Wrong headline prefix:\n$bad\n" && failure=true;}
 
 # check headline label for common typos
 bad=$(echo "$headlines" | grep --color=always \
@@ -98,14 +98,14 @@ bad=$(echo "$headlines" | grep --color=always \
 	-e 'test-pmd' \
 	-e '^bond:' \
 	| sed 's,^,\t,')
-[ -z "$bad" ] || printf "Wrong headline label:\n$bad\n"
+[ -z "$bad" ] || { printf "Wrong headline label:\n$bad\n" && failure=true;}
 
 # check headline lowercase for first words
 bad=$(echo "$headlines" | grep --color=always \
 	-e '^.*[[:upper:]].*:' \
 	-e ': *[[:upper:]]' \
 	| sed 's,^,\t,')
-[ -z "$bad" ] || printf "Wrong headline uppercase:\n$bad\n"
+[ -z "$bad" ] || { printf "Wrong headline uppercase:\n$bad\n" && failure=true;}
 
 # check headline case (Rx/Tx, VF, L2, MAC, Linux ...)
 IFS='
@@ -118,9 +118,8 @@ for word in $(cat $words); do
 	fi
 	for bad_line in $bad; do
 		bad_word=$(echo $bad_line | cut -d":" -f2 | grep -io $word)
-		if [ -n "$bad_word" ]; then
-			printf "Wrong headline case:\n\"$bad_line\": $bad_word --> $word\n"
-		fi
+		[ -z "$bad_word" ] || { printf "Wrong headline case:\n\
+			\"$bad_line\": $bad_word --> $word\n" && failure=true;}
 	done
 done
 
@@ -128,27 +127,28 @@ done
 bad=$(echo "$headlines" |
 	awk 'length>60 {print}' |
 	sed 's,^,\t,')
-[ -z "$bad" ] || printf "Headline too long:\n$bad\n"
+[ -z "$bad" ] || { printf "Headline too long:\n$bad\n" && failure=true;}
 
 # check body lines length (75 max)
 bad=$(echo "$bodylines" | grep -v '^Fixes:' |
 	awk 'length>75 {print}' |
 	sed 's,^,\t,')
-[ -z "$bad" ] || printf "Line too long:\n$bad\n"
+[ -z "$bad" ] || { printf "Line too long:\n$bad\n" && failure=true;}
 
 # check starting commit message with "It"
 bad=$(for commit in $commits ; do
 	firstbodyline=$(git log --format='%b' -1 $commit | head -n1)
 	echo "$firstbodyline" | grep --color=always -ie '^It '
 done | sed 's,^,\t,')
-[ -z "$bad" ] || printf "Wrong beginning of commit message:\n$bad\n"
+[ -z "$bad" ] || { printf "Wrong beginning of commit message:\n$bad\n"\
+	&& failure=true;}
 
 # check tags spelling
 bad=$(echo "$tags" |
 	grep -v "^$bytag [^,]* <.*@.*>$" |
 	grep -v '^Fixes: [0-9a-f]\{7\}[0-9a-f]* (".*")$' |
 	sed 's,^.,\t&,')
-[ -z "$bad" ] || printf "Wrong tag:\n$bad\n"
+[ -z "$bad" ] || { printf "Wrong tag:\n$bad\n" && failure=true;}
 
 # check missing Coverity issue: tag
 bad=$(for commit in $commits; do
@@ -157,7 +157,8 @@ bad=$(for commit in $commits; do
 	echo "$body" | grep -q '^Coverity issue:' && continue
 	git log --format='\t%s' -1 $commit
 done)
-[ -z "$bad" ] || printf "Missing 'Coverity issue:' tag:\n$bad\n"
+[ -z "$bad" ] || { printf "Missing 'Coverity issue:' tag:\n$bad\n"\
+	&& failure=true;}
 
 # check missing Bugzilla ID: tag
 bad=$(for commit in $commits; do
@@ -166,14 +167,15 @@ bad=$(for commit in $commits; do
 	echo "$body" | grep -q '^Bugzilla ID:' && continue
 	git log --format='\t%s' -1 $commit
 done)
-[ -z "$bad" ] || printf "Missing 'Bugzilla ID:' tag:\n$bad\n"
+[ -z "$bad" ] || { printf "Missing 'Bugzilla ID:' tag:\n$bad\n"\
+	&& failure=true;}
 
 # check missing Fixes: tag
 bad=$(for fix in $fixes ; do
 	git log --format='%b' -1 $fix | grep -q '^Fixes: ' ||
 		git log --format='\t%s' -1 $fix
 done)
-[ -z "$bad" ] || printf "Missing 'Fixes' tag:\n$bad\n"
+[ -z "$bad" ] || { printf "Missing 'Fixes' tag:\n$bad\n" && failure=true;}
 
 # check Fixes: reference
 fixtags=$(echo "$tags" | grep '^Fixes: ')
@@ -186,11 +188,22 @@ bad=$(for fixtag in $fixtags ; do
 	fi
 	printf "$fixtag" | grep -v "^$good$"
 done | sed 's,^,\t,')
-[ -z "$bad" ] || printf "Wrong 'Fixes' reference:\n$bad\n"
+[ -z "$bad" ] || { printf "Wrong 'Fixes' reference:\n$bad\n" && failure=true;}
 
 # check Cc: stable@dpdk.org for fixes
 bad=$(for fix in $stablefixes ; do
 	git log --format='%b' -1 $fix | grep -qi '^Cc: *stable@dpdk.org' ||
 		git log --format='\t%s' -1 $fix
 done)
-[ -z "$bad" ] || printf "Is it candidate for Cc: stable@dpdk.org backport?\n$bad\n"
+[ -z "$bad" ] || { printf "Is it candidate for Cc: stable@dpdk.org backport?\n$bad\n"\
+	&& failure=true;}
+
+total=$(echo "$commits" | wc -l)
+if [ -n "$failure" ] ; then
+	printf "\nInvalid patch(es) found - checked $total patch"
+else
+	printf "\n$total/$total valid patch"
+fi
+[ $total -le 1 ] || printf 'es'
+printf '\n'
+[ -n "$failure" ] && exit 1 || exit 0
-- 
2.17.1


  parent reply	other threads:[~2020-06-02 13:58 UTC|newest]

Thread overview: 26+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-01-28 15:02 [dpdk-dev] [PATCH 0/2] standardize devtools check scripts Ciara Power
2020-01-28 15:02 ` [dpdk-dev] [PATCH 1/2] devtools: standardize script arguments Ciara Power
2020-01-28 15:40   ` Ferruh Yigit
2020-02-22 20:53   ` Thomas Monjalon
2020-03-31 13:11     ` Power, Ciara
2020-01-28 15:02 ` [dpdk-dev] [PATCH 2/2] devtools: added stats print Ciara Power
2020-01-28 15:41   ` Ferruh Yigit
2020-02-22 20:55   ` Thomas Monjalon
2020-05-06  9:55 ` [dpdk-dev] [PATCH v2 0/2] standardize devtools check scripts Ciara Power
2020-05-06  9:55   ` [dpdk-dev] [PATCH v2 1/2] devtools: standardize script arguments Ciara Power
2020-05-24 20:57     ` Thomas Monjalon
2020-05-28 14:37       ` Power, Ciara
2020-05-28 15:03         ` Thomas Monjalon
2020-05-06  9:55   ` [dpdk-dev] [PATCH v2 2/2] devtools: added stats print Ciara Power
2020-06-02 13:53 ` [dpdk-dev] [PATCH v3 0/3] standardize devtools check scripts Ciara Power
2020-06-02 13:53   ` [dpdk-dev] [PATCH v3 1/3] devtools: standardize script arguments Ciara Power
2020-06-17  9:40     ` Thomas Monjalon
2020-06-02 13:53   ` Ciara Power [this message]
2020-06-02 13:53   ` [dpdk-dev] [PATCH v3 3/3] doc/guides: updated script usage for checking patches Ciara Power
2020-06-03 15:50     ` Ferruh Yigit
2020-06-17  9:46     ` Thomas Monjalon
2020-06-23  9:29 ` [dpdk-dev] [PATCH v4 0/2] standardize devtools check scripts Ciara Power
2020-06-23  9:29   ` [dpdk-dev] [PATCH v4 1/2] devtools: standardize script arguments Ciara Power
2020-06-23  9:29   ` [dpdk-dev] [PATCH v4 2/2] devtools: added stats print Ciara Power
2020-07-30 22:50     ` Thomas Monjalon
2020-07-30 22:52   ` [dpdk-dev] [PATCH v4 0/2] standardize devtools check scripts Thomas Monjalon

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200602135319.21457-3-ciara.power@intel.com \
    --to=ciara.power@intel.com \
    --cc=dev@dpdk.org \
    --cc=ferruh.yigit@intel.com \
    --cc=john.mcnamara@intel.com \
    --cc=marko.kovacevic@intel.com \
    --cc=thomas@monjalon.net \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).